package me.mrletsplay.simplenio.reader;

import java.io.IOException;
import java.util.function.Supplier;

import me.mrletsplay.simplenio.util.IOConsumer;
import me.mrletsplay.simplenio.util.IORunnable;

public class ExpectationImpl implements Expectation {

	private IOConsumer<ReaderInstance<?>> run;

	@Override
	public void orElseRun(IOConsumer<ReaderInstance<?>> run) {
		this.run = run;
	}

	@Override
	public void orElseRun(IORunnable run) {
		this.run = instance -> run.run();
	}

	@Override
	public void orElseThrow(Supplier<? extends IOException> exception) {
		this.run = instance -> { throw exception.get(); };
	}

	public void fail(ReaderInstance<?> instance) throws IOException {
		if(run == null) throw new IOException("Expectation failed");
		run.accept(instance);
	}

}
